import React, { createContext, useRef } from "preact/compat";
import render from "preact-render-to-string";
export const __DocContext = createContext({ head: { current: [] } });
export const Document = ({ styles = [], hasScripts = false, children }) => {
    const head = useRef([]);
    const subtree = render(React.createElement(__DocContext.Provider, { value: { head } }, children), {}, { pretty: true });
    return (React.createElement("html", null,
        React.createElement("head", null,
            React.createElement("meta", { charSet: "utf-8" }),
            React.createElement("meta", { name: "viewport", content: "width=device-width" }),
            React.createElement(React.Fragment, null, head.current),
            styles.map((style) => (React.createElement("style", { dangerouslySetInnerHTML: { __html: style } })))),
        React.createElement("body", null,
            React.createElement("script", { dangerouslySetInnerHTML: {
                    __html: "window.__hydrate={components:{}}",
                } }),
            React.createElement("div", { id: "__microsite", dangerouslySetInnerHTML: { __html: subtree } }),
            React.createElement("script", { src: "/hydrate.js", async: true }),
            hasScripts ? (React.createElement(React.Fragment, null,
                React.createElement("script", { type: "module", src: "/index.js" }),
                React.createElement("script", Object.assign({}, { nomodule: "" }, { src: "https://unpkg.com/systemjs@2.0.0/dist/s.min.js" })),
                React.createElement("script", Object.assign({}, { nomodule: "" }, { src: "/index.legacy.js" })))) : null)));
};
