import React, { forwardRef } from "preact/compat";
const isServer = typeof window === "undefined";
let id = 0;
export function withHydrate(Component) {
    return forwardRef((props, ref) => {
        id += 1;
        const scriptSrc = `window.__hydrate.components[${id}]={name:${JSON.stringify(Component.displayName || Component.name)},props:${JSON.stringify(props)}}`;
        return (React.createElement(React.Fragment, null,
            isServer && React.createElement("script", { dangerouslySetInnerHTML: { __html: scriptSrc } }),
            React.createElement("div", { style: { display: "contents" }, "data-hydrate": id },
                React.createElement(Component, Object.assign({}, Object.assign(Object.assign({}, props), { ref }))))));
    });
}
